Codeforces Round #400 (Div. 1 + Div. 2, combined)C. Molly's Chemicals【思维】

C. Molly's Chemicals
time limit per test
2.5 seconds
memory limit per test
512 megabytes
input
standard input
output
standard output

Molly Hooper has n different kinds of chemicals arranged in a line. Each of the chemicals has an affection value, The i-th of them has affection value ai.

Molly wants Sherlock to fall in love with her. She intends to do this by mixing a contiguous segment of chemicals together to make a love potion with total affection value as a non-negative integer power of k. Total affection value of a continuous segment of chemicals is the sum of affection values of each chemical in that segment.

Help her to do so in finding the total number of such segments.

Input

The first line of input contains two integers, n and k, the number of chemicals and the number, such that the total affection value is a non-negative power of this number k. (1 ≤ n ≤ 1051 ≤ |k| ≤ 10).

Next line contains n integers a1, a2, ..., an ( - 109 ≤ ai ≤ 109) — affection values of chemicals.

Output

Output a single integer — the number of valid segments.

Examples
input
4 2
2 2 2 2
output
8
input
4 -3
3 -6 -3 12
output
3
Note

Do keep in mind that k0 = 1.

In the first sample, Molly can get following different affection values:

  • 2: segments [1, 1][2, 2][3, 3][4, 4];

  • 4: segments [1, 2][2, 3][3, 4];

  • 6: segments [1, 3][2, 4];

  • 8: segments [1, 4].

Out of these, 24 and 8 are powers of k = 2. Therefore, the answer is 8.

In the second sample, Molly can choose segments [1, 2][3, 3][3, 4].


题目大意:

一个区间的价值【L,R】表示区间内所有元素的价值和。

问你一共有多少个区间的价值,是K的非负整数次幂(0,1,2,3,4,5............)。


思路:


1、显然直接枚举区间的左端点来滑动右端点的方式肯定是要超时的。

我们分析价值的本质:

①显然最大区间和的值是在1e14之内的。

②显然对于K的非负整数次幂得到的得数在1e14之内的数字量是非常小的,设定为cnt,每个数设定为poww【i】。


2、那么分析上述特性,我们可以先维护一个前缀和,然后对于cnt个数进行判定即可。

对于当前位子,从【1,i】的价值和是sum【i】,那么可以判定这cnt个数是否能够组成。

那么只要满足有:sum【i】-sum【ii】=poww【j】这样的等式存在,就有可行方案存在。

我们只要枚举这cnt个数然后看看是否有sum【i】-poww【j】这样的前缀和存在即可,如果存在,加上所有方案数即可;


Ac代码:

#include
#include
#include
using namespace std;
#define ll __int64
ll sum[100500];
ll a[100050];
ll poww[100050];
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        memset(sum,0,sizeof(sum));
        for(int i=0;i55||poww[cnt-1]>=1000000000000000)break;
            if(cnt==0)poww[cnt]=1;
            else poww[cnt]=poww[cnt-1]*m;
        }
        mapss;
        ss[0]=1;
        ll output=0;
        for(int i=0;iquchong;
            for(int j=0;j








你可能感兴趣的:(思维,Codeforces#400)